{%- from "ceph/map.jinja" import common with context %}

managed_echo:
  cmd.run:
  - name: echo "Managed keyrings are enabled"

{% for keyring_name, keyring in common.get('keyring', {}).iteritems() %}

  {%- set keyring_client_name = keyring.get('name', keyring_name) %}
  {%- set ceph_cluster = common.get('cluster_name', 'ceph') %}
  {%- set keyring_path = keyring.get('path', common.prefix_dir + '/etc/ceph/' + ceph_cluster + '.client.' + keyring_client_name + '.keyring') %}

  {%- if keyring_client_name == 'admin' and keyring.get(keyring_client_name, {}).caps is defined %}
    {# Reuse old logic from ceph.common #}
    {%- set create_keyring_file = False %}
  {%- else %}
    {%- set create_keyring_file = keyring.get('enabled', True) %}
  {%- endif %}

  {%- if create_keyring_file %}

managed_keyring_{{ keyring_path }}:
  file.managed:
  - name: {{ keyring_path }}
  - source: salt://ceph/files/keyring
  - template: jinja
  - user: {{ keyring.get('user', 'root') }}
  - group: {{ keyring.get('group', 'root') }}
  - mode: {{ keyring.get('mode', '640') }}
  - makedirs: true
  - defaults:
      keyring: {{ keyring|yaml }}
      name: {{ keyring.name }}

  {%- else %}

managed_keyring_{{ keyring_path }}:
  file.absent:
  - name: {{ keyring_path }}

  {%- endif %}

{%- endfor %}
